(* essai.ml - 10/9/2000
 *
 * This is a small example of what the OCamlHTML library is cappable of
 * Use Makefile to complie
 *
 * Copyright (C) 2000 Antoine Mine' (mine@di.ens.fr)
 *)

open Printf
open Date
open Html
open Http 
open Cgi

let main () =

  let date = get_date() in
  let d = Date.to_string date in
  add_days date (2);
  let dd = Date.to_string date in

  http_header ~date:d ~cache:[NoCache]
    ~cookie:[("Ha","Hi",dd);("Ho","Hu % () \\:",dd)] ();
  html_begin ~author:"Antoine Mine" "Essai";

  h1 "Ma vie, mon oeuvre, par Moi";
  p "Ceci est un joli essai!";

  form_begin ~meth:Get "a.out";
  form_text ~default:"Blha" "Toto";
  form_submit ();
  form_submit ~label:"Hi" (); 
  form_reset ();
  form_image_map "mon image" "http://www.ens.fr/images/ernests_petits.gif"
    "[Une image]";
  form_menu ~multiple:true "tototiti" 
    [Option (None,"a","Toto",true);Option (None,"b","Titi",false);
     Menu ("menu",[Option (None,"gagaa","GagaToto",true);
		    Option (None,"gagab","GagaTiti",false)])];
  form_end ();

  server_image_map 
    "http://dmi.ens.fr/cgi-bin/mine/a.out" 
    "http://www.ens.fr/images/ernests_petits.gif" "[Une image]";
  
  client_image_map
    "Totor" 
    "http://www.ens.fr/images/ernests_petits.gif" 
    "[Une image]"
    ~default_area:("","Ha")
    [(Rectangle ((0,0),(10,20)),"totor","Hi");
     (Circle ((50,50),20),"titir","Hoto")];
  
  p (link (build_cgi_url ()) "Myself");

  p (link (build_cgi_url ~args:[] ()) "Org");

  p (link (build_cgi_url ~args:[("Toto",Some "ha");("file",Some "&hi %")] ()) "Essai");


  (try
    let l = get_cgi_args () in 

    let rec toto = function
	[] -> ()
      |	(a,None)::l -> 
	  Printf.printf "<p>CGI arg: %s (No value)</p><br>\r\n" (escape_html a);
	  toto l
      |	(a,Some b)::l -> 
	  Printf.printf "<p>CGI arg: %s=\"%s\"</p><br>\r\n" (escape_html a) (escape_html b);
	  toto l
    in toto l;

    let l = get_cgi_cookies () in 

    let rec toto = function
	[] -> ()
      |	(a,None)::l -> 
	  Printf.printf "<p>Cookie: %s (No value)</p><br>\r\n" (escape_html a);
	  toto l
      |	(a,Some b)::l -> 
	  Printf.printf "<p>Cookie: %s=\"%s\"</p><br>\r\n" (escape_html a) (escape_html b);
	  toto l
    in toto l

  with _ -> p "F***"); 

  html_end ~author:"Antoine Min&eacute;" ~email:"mine@brick.ens.fr" (); 

;;


main () ;;
